--the script checks the database format
--and updates it to the latest version if necessary

--Sections table		  
IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'[dbo].[hdSections]') AND type in (N'U'))
BEGIN
	CREATE TABLE [dbo].[hdSections] (
	[SectionID] [int] IDENTITY (1, 1) NOT NULL PRIMARY KEY,
	[Name] [varchar] (50) NOT NULL
	)
END

--SectionID column
if not exists
	(select * from syscolumns where id=object_id('hdCategories') and name='SectionID')
begin
	  ALTER TABLE dbo.hdCategories
	  ADD SectionID int NULL
end

--RestrictIssueDeletion column
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='RestrictIssueClosing')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD RestrictIssueClosing bit NOT NULL DEFAULT 0
end

--adding EmailTemplate column
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='EmailTemplate')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD EmailTemplate varchar(2000) NOT NULL DEFAULT ('')
end

--adding Notes column for users
if not exists
	(select * from syscolumns where id=object_id('hdUsers') and name='Notes')
begin
	  ALTER TABLE dbo.hdUsers
	  ADD Notes varchar(4000) NOT NULL DEFAULT ('')
end

--MaxAttachSize column (maximum filesize for attachments in KB)
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='MaxAttachSize')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD MaxAttachSize int NOT NULL DEFAULT (1000)
end


--Lang column
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='Lang')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD Lang [varchar] (10) NOT NULL DEFAULT ('en-US')
end

--firstname/lastname columns
if not exists
	(select * from syscolumns where id=object_id('hdUsers') and name='FirstName')
begin
	  ALTER TABLE dbo.hdUsers
	  ADD FirstName varchar(255) NOT NULL DEFAULT ('')
end
if not exists
	(select * from syscolumns where id=object_id('hdUsers') and name='LastName')
begin
	  ALTER TABLE dbo.hdUsers
	  ADD LastName varchar(255) NOT NULL DEFAULT ('')
end


--Priority column
if not exists
	(select * from syscolumns where id=object_id('hdIssues') and name='Priority')
begin
	  ALTER TABLE dbo.hdIssues
	  ADD Priority smallint NOT NULL DEFAULT 0
end

--SMTPPort column
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='SMTPPort')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD SMTPPort int NOT NULL DEFAULT 25
end

--SMTPUseSSL column
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='SMTPUseSSL')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD SMTPUseSSL bit NOT NULL DEFAULT 0
end

--RestrictIssueDeletion column
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='RestrictIssueDeletion')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD RestrictIssueDeletion bit NOT NULL DEFAULT 0
end


--###########add MailChecker columns
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='MailCheckerEnabled')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD MailCheckerEnabled bit NOT NULL DEFAULT 0
end
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='MailCheckerInterval')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD MailCheckerInterval int NOT NULL DEFAULT 600
end
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='MailCheckerPOPServer')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD MailCheckerPOPServer varchar(50) NULL
end
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='MailCheckerPOPPort')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD MailCheckerPOPPort int NOT NULL DEFAULT (110)
end
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='MailCheckerPOPLogin')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD MailCheckerPOPLogin varchar(50) NULL
end
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='MailCheckerPOPPassword')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD MailCheckerPOPPassword varchar(50) NULL
end
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='MailCheckerUseSSL')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD MailCheckerUseSSL bit NOT NULL DEFAULT (0)
end
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='MailCheckerNewIssuesCategoryID')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD MailCheckerNewIssuesCategoryID int NOT NULL DEFAULT (1)
end
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='MailCheckerAllowUnregisteredUsers')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD MailCheckerAllowUnregisteredUsers bit NOT NULL DEFAULT (0)
end
--#############


--allowUserRegistration column
if not exists
	(select * from syscolumns where id=object_id('hdSettings') and name='AllowUserRegistration')
begin
	  ALTER TABLE dbo.hdSettings
	  ADD AllowUserRegistration bit NOT NULL
	  CONSTRAINT DF_hdSettings_AllowUserRegistration DEFAULT 1
end

--fileAttachments table
IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'[dbo].[hdFileAttachments]') AND type in (N'U'))
BEGIN
	CREATE TABLE [dbo].[hdFileAttachments](
		[FileID] [int] IDENTITY(1,1) PRIMARY KEY NOT NULL,
		[IssueID] [int] NOT NULL,
		[UserID] [int] NOT NULL,
		[FileName] [varchar](255) NOT NULL,
		[FileData] [image] NOT NULL,
	)
END
GO
IF NOT EXISTS (SELECT * FROM sysforeignkeys WHERE constid = OBJECT_ID(N'[dbo].[FK_hdFileAttachments_hdIssues]'))
ALTER TABLE [dbo].[hdFileAttachments] WITH CHECK ADD CONSTRAINT [FK_hdFileAttachments_hdIssues] FOREIGN KEY([IssueID])
REFERENCES [dbo].[hdIssues] ([IssueID])
GO
ALTER TABLE [dbo].[hdFileAttachments] CHECK CONSTRAINT [FK_hdFileAttachments_hdIssues]
GO
IF NOT EXISTS (SELECT * FROM sysforeignkeys WHERE constid = OBJECT_ID(N'[dbo].[FK_hdFileAttachments_hdUsers]'))
ALTER TABLE [dbo].[hdFileAttachments] WITH CHECK ADD CONSTRAINT [FK_hdFileAttachments_hdUsers] FOREIGN KEY([UserID])
REFERENCES [dbo].[hdUsers] ([UserID])
GO
ALTER TABLE [dbo].[hdFileAttachments] CHECK CONSTRAINT [FK_hdFileAttachments_hdUsers]
GO
--fileattachmetns table finished